/************************************************************************************
Random: Implements MT19937 by Takuji Nishimura and Makoto Matsumoto.

Some Code by Troy Lawlor Copyright (c)2005 All Rights Reserved.
MT19937 Code: Copyright (C) 1997 - 2002, Makoto Matsumoto and Takuji Nishimura,
   All rights reserved.

See TRandom.cpp for full MT19937 Copyright information.
*************************************************************************************/

#ifndef TAL_RANDOM_H
#define TAL_RANDOM_H

class Random {
	public:
		static Random global;
	
	private:
		static const int N=624;

		int numInitKeys;
		unsigned long *initKeys;
		unsigned long mt[N]; // the array for the state vector
		int mti; // mti==N+1 means mt[N] is not initialized

	private:
		void initByKey(unsigned long s);
		void initByKeys(unsigned long init_key[], int key_length);
		unsigned long genrand_int32(void);
		double genrand_real1();
		long genrand_int31();

	public:
		Random();
		Random(unsigned long p_key);
		Random(unsigned long init_key[], int numKeys);
		//Random(FILE* fp);
		~Random();

		Random& operator=( const Random& rh );
		Random( const Random& rh );

		int rangedInt( int low, int high );
		float rangedFloat( float low, float high );
		long genLong();
		double genDouble();
		float genFloat();

		//void writeKeys(FILE* fp);
};

#endif