/************************************************************************************
Timing: Provides global time keeping through static class Time.  The 'time constant'
defines how much Time will lie about the time passed.  1.0 means real time, 0.5 means
time will pass half as fast, etc. etc.  Call initTime() right before your main loop
to ensure there isn't a huge time difference after loading.

All Code by Troy Lawlor Copyright (c)2005 All Rights Reserved.
*************************************************************************************/

#ifndef TAL_TIMING_H
#define TAL_TIMING_H

class Time {
	public:
		static double systemTime();
};

class Timer {
	private:
		double gCurTime;
		double gLastTime;
		double gDifference;
		float timeConstant;
		
	public:
		Timer();
		void update();
		double getTime();
		void setTimeConstant(float what);
		void changeTimeConstant(float amount);
};

#endif
