/*
 *  main.cpp
 *  AirportSim
 *
 *  Created by Troy Lawlor on 2/2/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */
 
#include "AirportSim.h"
#include "Timing.h"
#include <GLUT/glut.h>
#include <iostream>

using namespace std;

int 		winWidth, winHeight;
Timer timer;

extern Airport airport;

float cx=0.3;
float cy=0.3;
float czoom=1.0;
bool running=true;
bool toDraw=true;

const int TOTAL_DAYS=1;

float minCost=0;
int whichMin=-1;
bool doneOne=false;

extern int gDays;
extern int gIteration;

void ortho(float left, float right, float bottom, float top, float znear, float zfar)
{
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glOrtho(left, right, bottom, top, znear, zfar);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

void init(void)
{
	//ortho(0, 1, 0, 1, -1, 100);
	airport.readParameters();
	airport.init();
}

bool drewOnce=false;

void redraw(void)
{
	if(!drewOnce) {
		drewOnce=true;
	}
	else {
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	glLoadIdentity();
	glTranslatef(0.5,0.5,0);
	glScalef(czoom,czoom,1);
	glTranslatef(-0.5,-0.5,0);
	glTranslatef(cx, cy,0);
    
	airport.draw();
	
    glutSwapBuffers();
	}
}


void reshape(int width, int height)
{
    glViewport(0, 0, width, height);
    winWidth = width;
    winHeight = height;
    glutPostRedisplay();
}

void keyboard(unsigned char key, int x, int y)
{
    switch(key) {
        case '=':
			airport.step(5.0f);
	    break;
		case 'r':
			running=!running;
		timer.update();
		break;
		case 'w': cy-=0.1f; break;
		case 'a': cx+=0.1f; break;
		case 's': cy+=0.1f; break;
		case 'd': cx-=0.1f; break;
		case 'v': czoom+=0.1f; break;
		case 'c': czoom-=0.1f; break;
		case 'b': airport.debugOutput(); break;
		case 'h': toDraw=!toDraw; break;
    }
			redraw();
}

void idle() {
	cout << "Let's rock" << endl;
	if(running) {
	while(true) {
		//timer.update();
		airport.step(10);
		if(gDays>=TOTAL_DAYS) {
			float tc = airport.die();
			//cout << "Finished I" << gIteration << " cost: $" << tc << endl;
			cout << tc << endl;
			if(!doneOne) { doneOne=true; minCost=tc; whichMin=gIteration; }
			else {
				if(tc<minCost) { minCost=tc; whichMin=gIteration; }
			}
			//cout << "Current leader: I" << whichMin << " cost: $" << minCost << endl;
			airport.tweakParameters();
			airport.writeParameters();
			airport.init();
			doneOne=true;
		}
		if(toDraw) redraw();
	}
	}
}


int main(int argc, char **argv)
{
    glutInitWindowSize(winWidth = 1024, winHeight = 1024);
    glutInit(&argc, argv);
    /* glutInitDisplayMode(GLUT_DOUBLE|GLUT_STENCIL|GLUT_DEPTH|GLUT_ALPHA); */
    (void)glutCreateWindow("Airport Simulation");
    glutDisplayFunc(redraw);
    glutKeyboardFunc(keyboard);
    glutReshapeFunc(reshape);
    glutReshapeFunc(reshape);
	glutIdleFunc(idle);
	
	init();
	idle();
    glutMainLoop();

    return 0;
}
