/************************************************************************************
All Code by Troy Lawlor Copyright (c)2005 All Rights Reserved.
*************************************************************************************/

#include "MathUtils.h"

float mapToRatio( float toMap, float l1, float h1, float l2, float h2 )
{
	return ((toMap-l1)/(h1-l1))*(h2-l2)+l2;
}

void clamp(int &toClamp, int low, int high) {
	if(toClamp<low) toClamp=low;
	else if(toClamp>high) toClamp=high;
}

void clamp(float &toClamp, float low, float high) {
	if(toClamp<low) toClamp=low;
	else if(toClamp>high) toClamp=high;
}

int min(const int &a, const int &b) {
	if(a<b) return a;
	else return b;
}

int max(const int &a, const int &b) {
	if(a>b) return a;
	else return b;
}

float min(const float &a, const float &b) {
	if(a<b) return a;
	else return b;
}

float max(const float &a, const float &b) {
	if(a>b) return a;
	else return b;
}

float min(const float &a, const float &b, const float &c) {
	float r1;
	if(a<=b) r1=a;
	else r1=b;
	if(r1<=c) return r1;
	else return c;
}

float max(const float &a, const float &b, const float &c) {
	float r1;
	if(a>=b) r1=a;
	else r1=b;
	if(r1>=c) return r1;
	else return c;
}

float lerp(const float &a, const float &b, const float &f) {
	return f * a + (1 - f) * b;
}

int sumRange(int n) {
	return (1+n)*(n/2);
}

int sumRange(int low, int high) {
	int range = high-low;
	return (1+range)*(range/2) + low*(range+1);
}

int sumEvenRange(int n) {
	return (n/2)*(n/2+1);
}

int avg( int a, int b ) {
	return (a+b)/2;
}

float avg( float a, float b ) {
	return (a+b)/2.0f;
}

float abs(float n) {
	if(n<0) return -n;
	else return n;
}

int sign(int n) {
	if(n<0) return -1;
	else if(n>0) return 1;
	else return 0;
}

float sign(float n) {
	if(n<0.0f) return -1.0f;
	else if(n>0.0f) return 1.0f;
	else return 0.0f;
}

bool inRange(const float&a, const float &l, const float&h) {
	return a>=l && a<=h;
}

int gcd(int a, int b) {
  int t;
  while (b != 0) {
    t = b;
    b = a % b;
    a = t;
  }
  return a;
}