/************************************************************************************
mathutils grab bag: A bunch of handy math functions and definitions

All Code by Troy Lawlor Copyright (c)2005 All Rights Reserved.
*************************************************************************************/

#ifndef MATH_MATHUTILS_H
#define MATH_MATHUTILS_H

#include <math.h>

#ifndef M_PI
#define M_PI 3.14159265
#endif

const float TO_RADIANS = 0.017452f;
const float TO_DEGREES = 180.0f/M_PI;

float mapToRatio( float toMap, float l1, float h1, float l2, float h2);  //  maps toMap in l1 to h1 to l2 to h2
void clamp(int &toClamp, int low, int high);
void clamp(float &toClamp, float low, float high);
int min(const int &a, const int &b);
int max(const int &a, const int &b);
float min(const float &a, const float &b);
float max(const float &a, const float &b);
float min(const float &a, const float &b, const float &c);
float max(const float &a, const float &b, const float &c);
float lerp(const float &a, const float &b, const float &f);
int sumRange(int n);
int sumRange(int low, int high);
int sumEvenRange(int n);
int avg( int a, int b );
float avg( float a, float b );
float abs(float n);
int sign(int n);
float sign(float n);
bool inRange(const float&a, const float &l, const float&h);
int gcd(int a, int b);

#endif
