// Randomtester.cpp
//  Used for development of code for quadric distribution
//	random variable class

#include <ctime>
#include <cstdlib>
#include <iostream>
#include <climits>

#include "Random.h"

Random r;

class Distribution {
public:
	virtual double getNumber() = 0;
};

class ArrivalDist : public Distribution {
public:
	static double arrival_dist_lookup[41];
	virtual double getNumber() {
		double num_p = r.rangedFloat(0.0, 0.999999999999);
		double num = num_p * 40;
		return( arrival_dist_lookup[int(num)]*(1.0-num_p) + arrival_dist_lookup[int(num + 1.0)]*num_p );
	}
};

double ArrivalDist::arrival_dist_lookup[41] = {
		0, 21.25, 28.05, 32.98, 37.23, 40.8, 44.03, 47.09, 49.81, 52.53, 55.08, 57.46,
		59.84, 62.22, 64.43, 66.64, 68.85, 71.06, 73.1, 75.31, 77.35, 79.56, 81.6, 83.81,
		85.85, 88.06, 90.27, 92.65, 94.86, 97.24, 99.79, 102.34, 105.06, 107.78, 110.84, 
		114.24, 117.81, 122.06, 127.33, 134.47, 170 };

ArrivalDist arrdist;

int main(void)
{

	for (int ii = 0; ii < 1000; ii++)
		std::cout << arrdist.getNumber() << std::endl;
	system("PAUSE");
}